<template>
  <v-card id="card" class="hello">
    <line-chart v-if="loaded" :chartData="chartData"></line-chart>
  </v-card>
</template>

<script>
import LineChart from "./LineChart";
import api from "../api";
import dateFormat from "date-format";
import dateCalc from "date-and-time";

export default {
  name: "HeatMap",
  components: {
    LineChart
  },
  data() {
    return {
      chartData: {
        labels: [],
        datasets: [
          {
            label: "כמות פוסטים",
            data: [],
            fill: false,
            borderColor: "#5e8b7e",
            tension: 0.2
          }
        ]
      },
      loaded: false
    };
  },
  props: {
    personId: {
      type: String,
      required: true
    }
  },
  created() {
    this.loadChart();
  },
  methods: {
    loadChart() {
      api
        .profile()
        .getPostsCounts(this.personId)
        .then(res => {
          const postsCounts = res.data.slice(0, 7).reverse();

          postsCounts.forEach(postCount => {
            const day = dateCalc.addDays(new Date(postCount.date), -1);
            const formattedDate = dateFormat.asString("dd/MM/yy", day);
            this.chartData.labels.push(formattedDate);
            this.chartData.datasets[0].data.push(postCount.postCount);
          });

          this.loaded = true;
        });
    }
  }
};
</script>

<style scoped>
#card {
  background-color: "#5e8b7e";
  border-color: "#5e8b7e";
  border-width: 1vw;
}
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
</style>
